@echo off

title DScmd-TV v0.2 (x64)

:: config
set DSCMD=bin\dscmd
set ELG=
set LOG_LEVEL=0
set REC_DIR=recordings

:: Connecting filters: 3 -> 8

:: CLSID constants
set CLSID_DefaultDirectSoundDevice={79376820-07D0-11CF-A24D-0020AFD79767}
set CLSID_FileWriter={8596E5F0-0DA5-11D0-BD21-00A0C911CE86}
set CLSID_GDCLMpeg4Multiplexor={5FD85181-E542-4E52-8D9D-5D613C30131B}
set CLSID_InfinitePinTeeFilter={F8388A40-D5BB-11D0-BE5A-0080C706568E}
set CLSID_LAVAudioDecoder={E8E73B6B-4CB3-44A4-BE99-4F7BCB96E491}
set CLSID_LAVSplitter={171252A0-8820-4AFE-9DF8-5C92B2D66B04}
set CLSID_LAVVideoDecoder={EE30215D-164F-4A92-A4EB-9D4C13390F9F}
set CLSID_URLReader={E436EBB6-524F-11CE-9F53-0020AF0BA770}
set CLSID_VideoRendererDefault={6BC1CFFA-8FC1-4261-AC22-CFB4CC38DB50}

:: defaults (window mode, simple playback)
set DS=%DSCMD% -i -live -v %LOG_LEVEL% %ELG% -graph %CLSID_URLReader%;src=
set mode=play

::::::::::::::::::::::::::::::::::::::::
:: HELP
::::::::::::::::::::::::::::::::::::::::
:help

echo.
echo DScmd-TV v0.2 (x64) - a player/recorder for HLS live streams of public TV stations
echo (c) 2018 Valentin Schmidt

echo.
echo Commands
echo ========

echo  c        Print command and channel list
echo  h        Print help for DScmd
echo  f        Activate strict fullscreen mode
echo  w        Activate window mode (default)
echo  r        Activate recording mode
echo  p        Activate standard playback mode (default)
echo  q        Quit

echo.
echo Channel list
echo ============

echo  1 = ARD
echo  2 = ZDF
echo  3 = Arte
echo  4 = 3sat
echo  5 = NDR
echo  6 = RBB
echo  7 = WDR
echo  8 = SWR
echo  9 = MDR
echo  10 = HR
echo  11 = BR

::::::::::::::::::::::::::::::::::::::::
:: MAIN LOOP
::::::::::::::::::::::::::::::::::::::::
:loopstart

echo.
set /P chan="Enter Channel-Number or Command: "

::::::::::::::::::::::::::::::::::::::::
:: COMMAND: SHOW CHANNELS AND COMMANDS
::::::::::::::::::::::::::::::::::::::::
if "%chan%"=="c" goto help

::::::::::::::::::::::::::::::::::::::::
:: COMMAND: SHOW DSCMD HELP
::::::::::::::::::::::::::::::::::::::::
if "%chan%"=="h" %DSCMD% -h & goto loopstart

::::::::::::::::::::::::::::::::::::::::
:: COMMAND: SET FULLSCREEN MODE
::::::::::::::::::::::::::::::::::::::::
if "%chan%"=="f" set DS=%DSCMD% -i -live -v %LOG_LEVEL% -fullScreen -hideCursor -graph %CLSID_URLReader%;src=& echo Fullscreen mode activated & goto loopstart

::::::::::::::::::::::::::::::::::::::::
:: COMMAND: SET WINDOW MODE
::::::::::::::::::::::::::::::::::::::::
if "%chan%"=="w" set DS=%DSCMD% -i -live -v %LOG_LEVEL% -graph %CLSID_URLReader%;src=& echo Window mode activated & goto loopstart

::::::::::::::::::::::::::::::::::::::::
:: COMMAND: SET RECORDING MODE
::::::::::::::::::::::::::::::::::::::::
if "%chan%"=="r" set mode=record& echo Recording mode activated & goto loopstart

::::::::::::::::::::::::::::::::::::::::
:: COMMAND: SET PLAYBACK MODE
::::::::::::::::::::::::::::::::::::::::
if "%chan%"=="p" set mode=play& echo Standard playback mode activated & goto loopstart

::::::::::::::::::::::::::::::::::::::::
:: COMMAND: QUIT
::::::::::::::::::::::::::::::::::::::::
if "%chan%"=="q" goto quit

::::::::::::::::::::::::::::::::::::::::
:: START PLAYING CHANNEL
::::::::::::::::::::::::::::::::::::::::
echo Starting Channel %chan% ...

goto %chan%

:1
call :playGraph ARD https://derste247livede.akamaized.net/hls/live/658317/daserste_de/master.m3u8
goto loopstart

:2
call :playGraph ZDF https://zdf1314-lh.akamaihd.net/i/de14_v1@392878/master.m3u8
goto loopstart

:3
call :playGraph Arte https://artelive-lh.akamaihd.net/i/artelive_de@393591/master.m3u8
goto loopstart

:4
call :playGraph 3sat http://zdf0910-lh.akamaihd.net/i/dach10_v1@392872/index_1496_av-p.m3u8
goto loopstart

:5
call :playGraph NDR https://ndrfs-lh.akamaihd.net/i/ndrfs_nds@430233/master.m3u8
goto loopstart

:6
call :playGraph RBB https://rbblive-lh.akamaihd.net/i/rbb_berlin@144674/master.m3u8
goto loopstart

:7
call :playGraph WDR https://wdrfsgeo-lh.akamaihd.net/i/wdrfs_geogeblockt@530016/master.m3u8
goto loopstart

:8
call :playGraph SWR https://swrbw-lh.akamaihd.net/i/swrbw_live@196738/master.m3u8
goto loopstart

:9
call :playGraph MDR https://mdrsnhls-lh.akamaihd.net/i/livetvmdrsachsen_de@513998/master.m3u8
goto loopstart

:10
call :playGraph HR https://hrlive1-lh.akamaihd.net/i/hr_fernsehen@75910/master.m3u8
goto loopstart

:11
call :playGraph BR https://brlive-lh.akamaihd.net/i/bfssued_germany@119890/master.m3u8
goto loopstart

:quit
exit

::::::::::::::::::::::::::::::::::::::::
::
::::::::::::::::::::::::::::::::::::::::
:playGraph
	if "%mode%"=="play" (
%DS%%2,%CLSID_LAVSplitter%;file=filters\LAVSplitter.ax,^
%CLSID_LAVVideoDecoder%;file=filters\LAVVideo.ax,^
%CLSID_VideoRendererDefault%,^
%CLSID_LAVAudioDecoder%;file=filters\LAVAudio.ax,^
%CLSID_DefaultDirectSoundDevice%!0:1,1:2,2:3,1:4,4:5^
 -winCaption %1
	) else (
%DS%%2,%CLSID_LAVSplitter%;file=filters\LAVSplitter.ax,^
%CLSID_InfinitePinTeeFilter%,^
%CLSID_InfinitePinTeeFilter%,^
%CLSID_GDCLMpeg4Multiplexor%;file=filters\mp4mux.dll,^
%CLSID_FileWriter%;dest=%REC_DIR%\%1_%date:~-4%%date:~3,2%%date:~0,2%_%time:~0,2%%time:~3,2%%time:~6,2%.mp4,^
%CLSID_LAVVideoDecoder%;file=filters\LAVVideo.ax,^
%CLSID_VideoRendererDefault%,^
%CLSID_LAVAudioDecoder%;file=filters\LAVAudio.ax,^
%CLSID_DefaultDirectSoundDevice%!0:1,1:2,1:3,2:4,3:4,4:5,2:6,6:7,3:8,8:9^
 -winCaption "%1 [RECORDING]"
	)
	exit /b
